package com.aucma.web.controller.system;

import java.util.List;
import java.util.Set;

import com.aucma.system.service.ISysPostService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;
import com.aucma.common.constant.Constants;
import com.aucma.common.core.domain.AjaxResult;
import com.aucma.common.core.domain.entity.SysMenu;
import com.aucma.common.core.domain.entity.SysUser;
import com.aucma.common.core.domain.model.LoginBody;
import com.aucma.common.utils.SecurityUtils;
import com.aucma.framework.web.service.SysLoginService;
import com.aucma.framework.web.service.SysPermissionService;
import com.aucma.system.service.ISysMenuService;

/**
 * 登录验证
 * 
 * @author ruoyi
 */
@RestController
public class SysLoginController
{
    @Autowired
    private SysLoginService loginService;

    @Autowired
    private ISysMenuService menuService;

    @Autowired
    private SysPermissionService permissionService;

    @Autowired
    private ISysPostService postService;

    /**
     * PDA登录
     * 
     * @param loginBody 登录信息
     * @return 结果
     */
    @PostMapping("/login")
    public AjaxResult login(@RequestBody LoginBody loginBody)
    {
        AjaxResult ajax = AjaxResult.success();
        // 生成令牌
        String token = loginService.login(loginBody.getUsername(), loginBody.getPassword(), "PDA_VALIDATE", loginBody.getUuid());
        ajax.put(Constants.TOKEN, token);
        return ajax;
    }

    /**
     * 系统登录
     *
     * @param loginBody 登录信息
     * @return 结果
     */
    @PostMapping("/indexLogin")
    public AjaxResult indexLogin(@RequestBody LoginBody loginBody)
    {
        AjaxResult ajax = AjaxResult.success();
        // 生成令牌
        String token = loginService.login(loginBody.getUsername(), loginBody.getPassword(), loginBody.getCode(),
                loginBody.getUuid());
        ajax.put(Constants.TOKEN, token);
        return ajax;
    }

    /**
     * 获取用户信息
     * 
     * @return 用户信息
     */
    @GetMapping("getInfo")
    public AjaxResult getInfo()
    {
        SysUser user = SecurityUtils.getLoginUser().getUser();
        // 角色集合
        Set<String> roles = permissionService.getRolePermission(user);
        // 权限集合
        Set<String> permissions = permissionService.getMenuPermission(user);
        AjaxResult ajax = AjaxResult.success();
        ajax.put("user", user);
        ajax.put("roles", roles);
        ajax.put("permissions", permissions);
        ajax.put("companyCode", "1000");
        ajax.put("companyName", "澳柯玛股份有限公司");
        ajax.put("factoryCode", "1301");
        ajax.put("factoryName", "河南民权工厂");
        List<Long> postList = postService.selectPostListByUserId(user.getUserId());
        ajax.put("postList", postList);
        if (postList.contains(121L)){
            //操作工返修措施权限
            ajax.put("userPermission", 0);
        } else if (postList.contains(9L)) {
            //超级返修措施权限
            ajax.put("userPermission", 2);
        } else {
            //普通返修措施权限
            ajax.put("userPermission", 1);
        }
        return ajax;
    }

    /**
     * 获取路由信息
     * 
     * @return 路由信息
     */
    @GetMapping("getRouters")
    public AjaxResult getRouters()
    {
        Long userId = SecurityUtils.getUserId();
        List<SysMenu> menus = menuService.selectMenuTreeByUserId(userId);
        return AjaxResult.success(menuService.buildMenus(menus));
    }
}
